/* jshint esversion:6 */
(function(){
    "use strict";

    let webviews = Array.from(document.querySelectorAll("webview"));
    function waitForLoad (wview) {
        return new Promise((resolve) => wview.addEventListener("loadstop", resolve));
    }

    let activeWebview,
        activeIdx;

    function activateWebview (idx) {
        activeWebview = 0;
        webviews.forEach(function (wview, i) {
            if (i === (idx % webviews.length)) {
                activeIdx = i;
                wview.style.display = "";
                activeWebview = wview;
            } else {
                wview.style.display = "none";
            }
        });
    }




    Promise.all(
        webviews.map(waitForLoad)
    ).then(
        () => {
            activateWebview(0);

            let form = document.querySelector("form");

            function findNext (query) {
                return new Promise((resolve) => activeWebview.find(query, {}, resolve));
            }

            document.getElementById("toggle").addEventListener("click", () => {
                activateWebview(activeIdx + 1);
                form.query.select();
                form.query.focus();
            });
            form.query.addEventListener("input", () => findNext(form.query.value));
            form.addEventListener("submit", (evt) => {
                evt.preventDefault();

                findNext(form.query.value);

                form.query.select();
                form.query.focus();
            });

            let autoTimeout = null,
                autoStep = 0;

            function scheduleAutoNext () {
                if (autoTimeout !== null) {
                    autoTimeout = setTimeout(autoNext, 50);
                }
            }

            function autoNext () {
                let step = autoStep;
                autoStep = (autoStep + 1) % 10;

                switch (step) {
                    case 0: activateWebview(activeIdx + 1); window.requestAnimationFrame(scheduleAutoNext); break;
                    case 1: findNext(form.query.value = "h").then(scheduleAutoNext); break;
                    case 2: findNext(form.query.value = "he").then(scheduleAutoNext); break;
                    case 3: findNext(form.query.value = "hel").then(scheduleAutoNext); break;
                    case 4: findNext(form.query.value = "hell").then(scheduleAutoNext); break;
                    case 5: findNext(form.query.value = "hello").then(scheduleAutoNext); break;
                    case 6: findNext(form.query.value = "hello").then(scheduleAutoNext); break;
                    case 7: findNext(form.query.value = "hello").then(scheduleAutoNext); break;
                    case 8: findNext(form.query.value = "hello").then(scheduleAutoNext); break;
                    case 9: findNext(form.query.value = "").then(scheduleAutoNext); break;

                    default: autoStep = 0; break;
                }
            }

            document.getElementById("auto").addEventListener("click", () => {
                if (autoTimeout === null) {
                    form.query.disabled = true;
                    form.submit_btn.disabled = true;
                    form.switch_btn.disabled = true;

                    autoStep = 0;
                    autoTimeout = -1;
                    autoNext();
                } else {
                    form.query.disabled = false;
                    form.submit_btn.disabled = false;
                    form.switch_btn.disabled = false;

                    clearTimeout(autoTimeout);
                    autoTimeout = null;
                }
            });

            document.body.classList.remove("loading");
            form.query.select();
            form.query.focus();
        }
    );

})();
